Subject: bug#41129: [External] : bug#41129: outline-mode: New keybindings for demote/promote/move-subtree

From: Drew Adams <[email-masked]>
Date: Fri, 29 Jan 2021 22:01:07 +0000

> > Indeed.  Major modes (like Org) have greater leeway in defining
> > keystrokes than minor modes, though -- a minor mode has to be more
> > careful not to redefine common keystrokes because there's less of a
> > "buy in" from users than with a major mode like Org.
> >
> > So it might make sense for Org to bind M-<right>
> > to something while it'd be too intrusive for
> > outline-minor-mode.

I agree with Lars, there.

A minor mode, even when local to a buffer (not
explicitly global), is in a sense "global" - it
works across other modes, and needs to play well
with them.
___

Not directly related, but I also think it's a
no-no for a major mode such as Org to globally
bind a key that has no business being used
(because useless) outside Org mode.  That's the
point of bug #46087 (which has received no reply).

In the past, Org mode has even countered the key
binding guidelines, by binding keys in its major
mode map that are supposed to be reserved for
minor modes.  (I think that after some protest
that's now been corrected.)

I can understand that Org developers and users
would like many keys available by default, but
there's also a need to play well with other,
non-Org, uses of Emacs.

> If I'm correct that the standard cursor movement bindings on
> M-<right>, M-<left> you're referring to are word movement
> commands, then they also have existing bindings on C-<right>
> and C-<left> and are at least very similar to M-f and M-b.

Yes.

> So perhaps it's ok if outline-minor-mode shadows the
> M-<arrow> flavor of them, particularly if it aligns with
> org-mode.

Personally, I'd prefer that Emacs not bind
`M-left|right' keys by default, including in
Outline or Org modes (minor or major).

(I bind `M-left|right|up|down' to commands
that incrementally move the selected frame.)